from datetime import datetime
from typing import Optional

from cpl_core.database import TableABC

from bot_data.model.server import Server


class Realm(TableABC):
    def __init__(
        self,
        name: str,
        role_id: int,
        server: Optional[Server],
        created_at: datetime = None,
        modified_at: datetime = None,
        id=0,
    ):
        self._id = id
        self._name = name
        self._role_id = role_id
        self._server = server

        TableABC.__init__(self)
        self._created_at = created_at if created_at is not None else self._created_at
        self._modified_at = modified_at if modified_at is not None else self._modified_at

    @property
    def id(self) -> int:
        return self._id

    @property
    def name(self) -> str:
        return self._name

    @name.setter
    def name(self, value: str):
        self._name = value

    @property
    def role_id(self) -> int:
        return self._role_id

    @role_id.setter
    def role_id(self, value: int):
        self._role_id = value

    @property
    def server(self) -> Server:
        return self._server

    @staticmethod
    def get_select_all_string() -> str:
        return str(
            f"""
            SELECT * FROM `Realms`;
        """
        )

    @staticmethod
    def get_select_by_id_string(id: int) -> str:
        return str(
            f"""
            SELECT * FROM `Realms`
            WHERE `RealmId` = {id};
        """
        )

    @staticmethod
    def get_select_by_server_id_string(id: int) -> str:
        return str(
            f"""
            SELECT * FROM `Realms`
            WHERE `ServerId` = {id};
        """
        )

    @staticmethod
    def get_select_by_name_string(name: str) -> str:
        return str(
            f"""
            SELECT * FROM `Realms`
            WHERE `Name` = '{name}';
        """
        )

    @property
    def insert_string(self) -> str:
        return str(
            f"""
            INSERT INTO `Realms` (
                `ServerId`, `Name`, `RoleId`
            ) VALUES (
                {self._server.id},
                '{self._name}',
                {self._role_id}
            );
        """
        )

    @property
    def udpate_string(self) -> str:
        return str(
            f"""
            UPDATE `Realms`
            SET `ServerId` = {self._server.id},
            `Name` = '{self._name}',
            `RoleId` = {self._role_id}
            WHERE `RealmId` = {self._id};
        """
        )

    @property
    def delete_string(self) -> str:
        return str(
            f"""
            DELETE FROM `Realms`
            WHERE `RealmId` = {self._id};
        """
        )
