from typing import Optional

from bot_data.abc.history_table_abc import HistoryTableABC
from bot_data.model.server import Server


class Realm(HistoryTableABC):
    def __init__(
        self,
        server: Optional[Server],
        name: str,
        role_id: int,
        deleted: bool,
        date_from: str,
        date_to: str,
        id=0,
    ):
        HistoryTableABC.__init__(self)

        self._id = id
        self._server = server
        self._name = name
        self._role_id = role_id

        self._deleted = deleted
        self._date_from = date_from
        self._date_to = date_to

    @property
    def id(self) -> int:
        return self._id

    @property
    def server(self) -> Server:
        return self._server

    @property
    def name(self) -> str:
        return self._name

    @property
    def role_id(self) -> int:
        return self._role_id
